import sys, io, fcntl, time, datetime

PASSWD_FILE = '/tmp/passwd'

#old version
def add_user(login, uid, gid, name, home, shell='/bin/bash'):
    fields = login, 'x', str(uid), str(gid), name, home, shell
    f = open(PASSWD_FILE, 'a')
    try:
        fcntl.lockf(f.fileno(), fcntl.LOCK_EX)
        f.seek(0, io.SEEK_END)
        f.write(':'.join(fields[:3]) + ':')
        f.flush()
        time.sleep(1)
        f.write(':'.join(fields[3:]) + '\n')
        f.flush()
    finally:
        fcntl.lockf(f.fileno(), fcntl.LOCK_UN)

def main(prog_name, count):
    for i in range(int(count)):
         now = datetime.datetime.now()
         uid = now.minute * 60 + now.second
         gid = now.microsecond//1000
         add_user('login', uid, gid, 'name', 'home')
         print('added uid={}'.format(uid))

if __name__ ==  '__main__':
    sys.exit(main(*sys.argv))
